#include "../binary_c.h"
No_empty_translation_unit_warning;

#ifdef NUCSYN

#ifdef __HAVE_LIBSUNDIALS_CVODE__

#include "../maths/cvode.h"
#include <cvode/cvode.h>

/*
 * Network code : coldCNO
 * Automatically generated by make_reaction_network_code.pl
 */

/*
 * Reaction SIGMAV_T12 C12(H1,gamma0)C13
 * Alpha=C12, beta=H1, gamma=gamma0, delta=C13
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T13 C13(H1,gamma0)N14
 * Alpha=C13, beta=H1, gamma=gamma0, delta=N14
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T14 N14(H1,gamma0)N15
 * Alpha=N14, beta=H1, gamma=gamma0, delta=N15
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T15 N15(H1,He4)C12
 * Alpha=N15, beta=H1, gamma=He4, delta=C12
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T15_BRANCH N15(H1,gamma0)O16
 * Alpha=N15, beta=H1, gamma=gamma0, delta=O16
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T16 O16(H1,gamma0)O17
 * Alpha=O16, beta=H1, gamma=gamma0, delta=O17
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_T17 O17(H1,He4)N14
 * Alpha=O17, beta=H1, gamma=He4, delta=N14
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_O17G O17(H1,gamma0)O18
 * Alpha=O17, beta=H1, gamma=gamma0, delta=O18
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_O18A O18(H1,He4)N15
 * Alpha=O18, beta=H1, gamma=He4, delta=N15
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_O18G O18(H1,gamma0)F19
 * Alpha=O18, beta=H1, gamma=gamma0, delta=F19
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_F19A F19(H1,He4)O16
 * Alpha=F19, beta=H1, gamma=He4, delta=O16
 * m=1, n=1, p=1, q=1
 */


/*
 * Species / Reactions list:
 *
 * 1 : H1 : -C12*H1*SIGMAV_T12 -C13*H1*SIGMAV_T13 -N14*H1*SIGMAV_T14 -N15*H1*SIGMAV_T15 -N15*H1*SIGMAV_T15_BRANCH -O16*H1*SIGMAV_T16 -O17*H1*SIGMAV_T17 -O17*H1*SIGMAV_O17G -O18*H1*SIGMAV_O18A -O18*H1*SIGMAV_O18G -F19*H1*SIGMAV_F19A
 * 2 : He4 : +N15*H1*SIGMAV_T15 +O17*H1*SIGMAV_T17 +O18*H1*SIGMAV_O18A +F19*H1*SIGMAV_F19A
 * 3 : C12 : -C12*H1*SIGMAV_T12 +N15*H1*SIGMAV_T15
 * 4 : C13 : +C12*H1*SIGMAV_T12 -C13*H1*SIGMAV_T13
 * 5 : N14 : +C13*H1*SIGMAV_T13 -N14*H1*SIGMAV_T14 +O17*H1*SIGMAV_T17
 * 6 : N15 : +N14*H1*SIGMAV_T14 -N15*H1*SIGMAV_T15 -N15*H1*SIGMAV_T15_BRANCH +O18*H1*SIGMAV_O18A
 * 7 : O16 : +N15*H1*SIGMAV_T15_BRANCH -O16*H1*SIGMAV_T16 +F19*H1*SIGMAV_F19A
 * 8 : O17 : +O16*H1*SIGMAV_T16 -O17*H1*SIGMAV_T17 -O17*H1*SIGMAV_O17G
 * 9 : O18 : +O17*H1*SIGMAV_O17G -O18*H1*SIGMAV_O18A -O18*H1*SIGMAV_O18G
 * 10 : F19 : +O18*H1*SIGMAV_O18G -F19*H1*SIGMAV_F19A
 *
 */


#define NSPECIES 10

/*
 * Order in which to map from binary_c's isotope
 * array, N[], to y[] used in CVODE. Note that the
 * first element is ignored because CVODE starts
 * counting at 1, use an isotope that exists
 * but is not of interest.
 */
#define CNOMAP_LIST \
    X(  H1)         \
    X( He4)         \
    X( C12)         \
    X( C13)         \
    X( N14)         \
    X( N15)         \
    X( O16)         \
    X( O17)         \
    X( O18)         \
    X( F19)
#undef X
#define X(ISO) MAP_##ISO,
    enum { _DUMMY, CNOMAP_LIST };
#undef X



static int coldCNOderivatives_cvode(realtype t,
                                    N_Vector y,
                                    N_Vector ydot,
                                    void *user_data);

static int coldCNOjacobian_cvode(realtype t Maybe_unused,
                                 N_Vector y Maybe_unused,
                                 N_Vector fy Maybe_unused,
                                 SUNMatrix J Maybe_unused,
                                 void *user_data,
                                 N_Vector tmp1 Maybe_unused,
                                 N_Vector tmp2 Maybe_unused,
                                 N_Vector tmp3 Maybe_unused);
static Boolean was_error(void *returnvalue, int opt);

double nucsyn_burn_cvode_coldCNO(struct stardata_t * const Restrict stardata,
                                 double * const Nin,
                                 const double * const sigmav,
                                 const double h)
{
    /*
     * https://computing.llnl.gov/projects/sundials/cvode
     *
     * https://computing.llnl.gov/sites/default/files/cv_guide-5.7.0.pdf
     * https://computing.llnl.gov/sites/default/files/cv_examples-5.7.0.pdf
     */
    double err = 0.0;

    /*
     * data passed in to the derivatives function
     */
    struct cvode_data_t data;
    data.sigmav = (double*)sigmav;
    data.N = (double*)Nin;
    data.stardata = stardata;

    int retval;

    /*
     * Get a pointer to the tmpstore context
     * structure, or allocate it.
     */
    struct cvode_context_t * c = stardata->tmpstore->cvode[NUCSYN_NETWORK_COLDCNO];
    if(c == NULL)
    {
        /*
         * Allocate CVODE context struct
         */
        c = Calloc(1,sizeof(struct cvode_context_t));
        stardata->tmpstore->cvode[NUCSYN_NETWORK_COLDCNO] = c;
    }

    if(c->cvode_mem == NULL)
    {
        /*
         * Initialize memory in the context structure.
         */
        c->y = N_VNew_Serial(NSPECIES);
        if(was_error((void *)c->y, 0) == TRUE)
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /*
         * set initial values c->y from Nin
         */
#define X(ISO) Ith(c->y,i) = Nin[X##ISO]; i++;
        { int i = 1 ; CNOMAP_LIST; }
#undef X

        /* Call CVodeCreate to create the solver memory and specify the
         * Backward Differentiation Formula */
        c->cvode_mem = CVodeCreate(CV_BDF);
        if(was_error((void *)c->cvode_mem, 0) == TRUE)
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Call CVodeInit to initialize the integrator memory and specify the
         * user's right hand side function in y'=f(t,y), the inital time 0.0, and
         * the initial dependent variable vector y. */
        retval = CVodeInit(c->cvode_mem, coldCNOderivatives_cvode, 0.0, c->y);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /*
         * Attach our data to the cvode memory block
         */
        CVodeSetUserData(c->cvode_mem, (void*)&data);

        /* Create dense SUNMatrix for use in linear solves */
        c->A = SUNDenseMatrix(NSPECIES, NSPECIES);
        if(was_error((void *)c->A, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Create dense SUNLinearSolver object for use by CVode */
        c->LS = SUNLinSol_Dense(c->y, c->A);
        if(was_error((void *)c->LS, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Create serial vector of length NSPECIES abstol */
        c->abstol = N_VNew_Serial(NSPECIES);
        if(was_error((void *)c->abstol, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Call CVodeSetLinearSolver to attach the matrix and linear solver to CVode */
        retval = CVodeSetLinearSolver(c->cvode_mem, c->LS, c->A);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                          "CVODE returned %d : failed to attach matrix and linear solver\n",retval);
        }

        /* Set the user-supplied Jacobian routine  */
        retval = CVodeSetJacFn(c->cvode_mem, coldCNOjacobian_cvode);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                          "CVODE returned %d : failed to set Jacobian\n",retval);
        }
    }
    else
    {
        /*
         * set initial values c->y from Nin
         */
#define X(ISO) Ith(c->y,i) = Nin[X##ISO]; i++;
        { int i = 1 ; CNOMAP_LIST; }
#undef X

        /*
         * We need to call CVodeReInit
         */
        CVodeReInit(c->cvode_mem,0.0,c->y);
        /*
         * Re-Attach our data to the cvode memory block,
         * in case some of it has changed
         */
        CVodeSetUserData(c->cvode_mem, (void*)&data);
    }


    /* Set the scalar relative tolerance */
    const realtype reltol = 1e-10;

    /*
     * Set the vector absolute tolerance
     * from 1e-3 * abundance
     */
#define X(ISO) Ith(c->abstol,i) = Max(1.0,1e-40*Nin[X##ISO]); i++;
    { int i = 1; CNOMAP_LIST; }
#undef X

    /*
     * Set max number of steps
     */
    CVodeSetMaxNumSteps(c->cvode_mem, LONG_MAX);

    /*
     * Call CVodeSVtolerances to specify the tolerances
     */
    retval = CVodeSVtolerances(c->cvode_mem, reltol, c->abstol);
    if(was_error(&retval, 1))
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "CVODE returned %d : failed to set tolerances\n",retval);
    }

    /*
     * Call CVODE solver.
     */
    realtype t = 0.0;

    retval = CVode(c->cvode_mem, h, c->y, &t, CV_NORMAL);
    if(retval != 0.0)
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "CVODE returned %d\n",retval);
    }


    /* CVODE to C */
#define X(ISO) (Nin)[X##ISO] = Ith(c->y,i); i++;
    { int i = 1 ; CNOMAP_LIST; }
#undef X
    return err;
}



static int coldCNOderivatives_cvode(realtype t Maybe_unused,
                                    N_Vector y Maybe_unused,
                                    N_Vector ydot,
                                    void *user_data Maybe_unused)
{
    struct cvode_data_t * const Restrict cvode_data =
        (struct cvode_data_t * const Restrict)user_data;
    const double * const Restrict sigmav =
        (const double * const Restrict) cvode_data->sigmav;

    /*
     * Note: you must set all the items in ydot,
     * they are not automatically set to zero by CVODE.
     */
    const double dummy0 = Ith(y,9) * Ith(y,1) * sigmav[SIGMAV_O18G] ;
    const double dummy1 = Ith(y,6) * Ith(y,1) * sigmav[SIGMAV_T15] ;
    const double dummy2 = Ith(y,8) * Ith(y,1) * sigmav[SIGMAV_T17] ;
    const double dummy3 = Ith(y,9) * Ith(y,1) * sigmav[SIGMAV_O18A] ;
    const double dummy4 = Ith(y,7) * Ith(y,1) * sigmav[SIGMAV_T16] ;
    const double dummy5 = Ith(y,4) * Ith(y,1) * sigmav[SIGMAV_T13] ;
    const double dummy6 = Ith(y,10) * Ith(y,1) * sigmav[SIGMAV_F19A] ;
    const double dummy7 = Ith(y,3) * Ith(y,1) * sigmav[SIGMAV_T12] ;
    const double dummy8 = Ith(y,5) * Ith(y,1) * sigmav[SIGMAV_T14] ;
    const double dummy9 = Ith(y,6) * Ith(y,1) * sigmav[SIGMAV_T15_BRANCH] ;
    const double dummy10 = Ith(y,8) * Ith(y,1) * sigmav[SIGMAV_O17G] ;
    Ith(ydot,1) = - dummy7  - dummy5  - dummy8  - dummy1  - dummy9  - dummy4  - dummy2  - dummy10  - dummy3  - dummy0  - dummy6 ;
    Ith(ydot,2) = + dummy1  + dummy2  + dummy3  + dummy6 ;
    Ith(ydot,3) = - dummy7  + dummy1 ;
    Ith(ydot,4) = + dummy7  - dummy5 ;
    Ith(ydot,5) = + dummy5  - dummy8  + dummy2 ;
    Ith(ydot,6) = + dummy8  - dummy1  - dummy9  + dummy3 ;
    Ith(ydot,7) = + dummy9  - dummy4  + dummy6 ;
    Ith(ydot,8) = + dummy4  - dummy2  - dummy10 ;
    Ith(ydot,9) = + dummy10  - dummy3  - dummy0 ;
    Ith(ydot,10) = + dummy0  - dummy6 ;

    return 0;
}

static int coldCNOjacobian_cvode(realtype t Maybe_unused,
                                 N_Vector y Maybe_unused,
                                 N_Vector fy Maybe_unused,
                                 SUNMatrix J Maybe_unused,
                                 void *user_data,
                                 N_Vector tmp1 Maybe_unused,
                                 N_Vector tmp2 Maybe_unused,
                                 N_Vector tmp3 Maybe_unused)
{
    struct cvode_data_t * const Restrict cvode_data =
        (struct cvode_data_t * const Restrict)user_data;
    const double * const Restrict sigmav =
        (const double * const Restrict) cvode_data->sigmav;
    /*
     * Note: J is zero on entry, according to the CVOD
     * documentation...
     */
    /*
      for(int i=1;i<=NSPECIES;i++)
      {
      for(int j=1;j<=NSPECIES;j++)
      {
      IJth(J,i,j) = 0.0;
      }
      }
    */
    const double dummy0 = Ith(y,MAP_F19) * sigmav[SIGMAV_F19A] ;
    const double dummy1 = Ith(y,MAP_O16) * sigmav[SIGMAV_T16] ;
    const double dummy2 = Ith(y,MAP_H1) * sigmav[SIGMAV_T14] ;
    const double dummy3 = Ith(y,MAP_O17) * sigmav[SIGMAV_O17G] ;
    const double dummy4 = Ith(y,MAP_H1) * sigmav[SIGMAV_T16] ;
    const double dummy5 = Ith(y,MAP_O18) * sigmav[SIGMAV_O18G] ;
    const double dummy6 = Ith(y,MAP_H1) * sigmav[SIGMAV_T17] ;
    const double dummy7 = Ith(y,MAP_H1) * sigmav[SIGMAV_T13] ;
    const double dummy8 = Ith(y,MAP_H1) * sigmav[SIGMAV_O18A] ;
    const double dummy9 = Ith(y,MAP_H1) * sigmav[SIGMAV_O18G] ;
    const double dummy10 = Ith(y,MAP_N15) * sigmav[SIGMAV_T15] ;
    const double dummy11 = Ith(y,MAP_N15) * sigmav[SIGMAV_T15_BRANCH] ;
    const double dummy12 = Ith(y,MAP_H1) * sigmav[SIGMAV_O17G] ;
    const double dummy13 = Ith(y,MAP_O17) * sigmav[SIGMAV_T17] ;
    const double dummy14 = Ith(y,MAP_H1) * sigmav[SIGMAV_F19A] ;
    const double dummy15 = Ith(y,MAP_C13) * sigmav[SIGMAV_T13] ;
    const double dummy16 = Ith(y,MAP_O18) * sigmav[SIGMAV_O18A] ;
    const double dummy17 = Ith(y,MAP_H1) * sigmav[SIGMAV_T15_BRANCH] ;
    const double dummy18 = Ith(y,MAP_H1) * sigmav[SIGMAV_T12] ;
    const double dummy19 = Ith(y,MAP_N14) * sigmav[SIGMAV_T14] ;
    const double dummy20 = Ith(y,MAP_C12) * sigmav[SIGMAV_T12] ;
    const double dummy21 = Ith(y,MAP_H1) * sigmav[SIGMAV_T15] ;
    IJth(J,1,1) =    - dummy5 - dummy16 - dummy1- dummy15 - dummy10 - dummy13 - dummy11 - dummy3 - dummy0 - dummy19 - dummy20;
    IJth(J,1,3) =   - dummy18;
    IJth(J,1,4) =   - dummy7;
    IJth(J,1,5) =   - dummy2;
    IJth(J,1,6) =   - dummy21  - dummy17;
    IJth(J,1,7) =   - dummy4;
    IJth(J,1,8) =   - dummy6  - dummy12;
    IJth(J,1,9) =   - dummy9  - dummy8;
    IJth(J,1,10) =   - dummy14;
    IJth(J,2,1) =   + dummy16  + dummy10  + dummy0  + dummy13;
    IJth(J,2,6) =   + dummy21;
    IJth(J,2,8) =   + dummy6;
    IJth(J,2,9) =   + dummy8;
    IJth(J,2,10) =   + dummy14;
    IJth(J,3,1) =   - dummy20  + dummy10;
    IJth(J,3,3) =   - dummy18;
    IJth(J,3,6) =   + dummy21;
    IJth(J,4,1) =   - dummy15  + dummy20;
    IJth(J,4,3) =   + dummy18;
    IJth(J,4,4) =   - dummy7;
    IJth(J,5,1) =   + dummy15  - dummy19  + dummy13;
    IJth(J,5,4) =   + dummy7;
    IJth(J,5,5) =   - dummy2;
    IJth(J,5,8) =   + dummy6;
    IJth(J,6,1) =   + dummy16  - dummy10  - dummy11  + dummy19;
    IJth(J,6,5) =   + dummy2;
    IJth(J,6,6) =   - dummy21  - dummy17;
    IJth(J,6,9) =   + dummy8;
    IJth(J,7,1) =   - dummy1  + dummy0  + dummy11;
    IJth(J,7,6) =   + dummy17;
    IJth(J,7,7) =   - dummy4;
    IJth(J,7,10) =   + dummy14;
    IJth(J,8,1) =   + dummy1  - dummy13  - dummy3;
    IJth(J,8,7) =   + dummy4;
    IJth(J,8,8) =   - dummy12  - dummy6;
    IJth(J,9,1) =   - dummy5  - dummy16  + dummy3;
    IJth(J,9,8) =   + dummy12;
    IJth(J,9,9) =   - dummy9  - dummy8;
    IJth(J,10,1) =   + dummy5  - dummy0;
    IJth(J,10,9) =   + dummy9;
    IJth(J,10,10) =   - dummy14;


    return 0;
}

static Boolean was_error(void *returnvalue,
                         int opt)
{
    /*
     * return TRUE on error
     */
    return ((opt == 0 && returnvalue == NULL)||
            (opt == 1 && *((int*)returnvalue)<0) ||
            (opt == 2 && returnvalue == NULL)) ? TRUE : FALSE;
}

#endif // __HAVE_LIBSUNDIALS_CVODE__



#endif // NUCSYN &&
